using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using System.Threading;
using System.Net.Sockets;
using System.IO;
using System.Text;
using System.ComponentModel;



namespace GUI
{
	/// <summary>
	/// Erstellt das Fenster fr die eigentliche Anwendung
    /// der Port des Servers und der Sensortyp sind fest
    /// voreigestellt
    /// 
	/// </summary>
	public class GUI : Form
    {
        private TextBox Server_Box;
        private Label Server_Label;
        private Label MessPort_Label;
        private Label Port_Label;
        private Button Abfrage_Button;
        private SplitContainer splitContainer1;
        private Label Anzeige_Text;
        private RichTextBox Anzeige;
        private Label Type_Label;
        private Panel Select_Panel;
        private Panel Anzeige_Panel;
        private Label Type_Display_Label;
        private Label Port_Text;
        private Label Temperatur;
        private TextBox MessPort_Box;
        

        //Konstruktor 
        public GUI()
        {
           InitializeComponent();
        }
		
        //die Komponenten des Fensters werden erstellt
        private void InitializeComponent()
        {
            this.splitContainer1 = new System.Windows.Forms.SplitContainer();
            this.Select_Panel = new System.Windows.Forms.Panel();
            this.MessPort_Box = new System.Windows.Forms.TextBox();
            this.Port_Text = new System.Windows.Forms.Label();
            this.Temperatur = new System.Windows.Forms.Label();
            this.Type_Label = new System.Windows.Forms.Label();
            this.Server_Box = new System.Windows.Forms.TextBox();
            this.Abfrage_Button = new System.Windows.Forms.Button();
            this.MessPort_Label = new System.Windows.Forms.Label();
            this.Server_Label = new System.Windows.Forms.Label();
            this.Port_Label = new System.Windows.Forms.Label();
            this.Anzeige_Panel = new System.Windows.Forms.Panel();
            this.Type_Display_Label = new System.Windows.Forms.Label();
            this.Anzeige = new System.Windows.Forms.RichTextBox();
            this.Anzeige_Text = new System.Windows.Forms.Label();
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            this.Select_Panel.SuspendLayout();
            this.Anzeige_Panel.SuspendLayout();
            this.SuspendLayout();
            // 
            // splitContainer1
            // 
            this.splitContainer1.Location = new System.Drawing.Point(11, 12);
            this.splitContainer1.Name = "splitContainer1";
            // 
            // splitContainer1.Panel1
            // 
            this.splitContainer1.Panel1.Controls.Add(this.Select_Panel);
            // 
            // splitContainer1.Panel2
            // 
            this.splitContainer1.Panel2.Controls.Add(this.Anzeige_Panel);
            this.splitContainer1.Size = new System.Drawing.Size(487, 198);
            this.splitContainer1.SplitterDistance = 242;
            this.splitContainer1.TabIndex = 8;
            // 
            // Select_Panel
            // 
            this.Select_Panel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.Select_Panel.Controls.Add(this.MessPort_Box);
            this.Select_Panel.Controls.Add(this.Port_Text);
            this.Select_Panel.Controls.Add(this.Temperatur);
            this.Select_Panel.Controls.Add(this.Type_Label);
            this.Select_Panel.Controls.Add(this.Server_Box);
            this.Select_Panel.Controls.Add(this.Abfrage_Button);
            this.Select_Panel.Controls.Add(this.MessPort_Label);
            this.Select_Panel.Controls.Add(this.Server_Label);
            this.Select_Panel.Controls.Add(this.Port_Label);
            this.Select_Panel.Location = new System.Drawing.Point(1, 3);
            this.Select_Panel.Name = "Select_Panel";
            this.Select_Panel.Size = new System.Drawing.Size(237, 191);
            this.Select_Panel.TabIndex = 10;
            // 
            // MessPort_Box
            // 
            this.MessPort_Box.Location = new System.Drawing.Point(97, 73);
            this.MessPort_Box.Name = "MessPort_Box";
            this.MessPort_Box.Size = new System.Drawing.Size(114, 20);
            this.MessPort_Box.TabIndex = 11;
            this.MessPort_Box.Text = "pcmeasure.com1.1";
            // 
            // Port_Text
            // 
            this.Port_Text.AutoSize = true;
            this.Port_Text.Location = new System.Drawing.Point(94, 49);
            this.Port_Text.Name = "Port_Text";
            this.Port_Text.Size = new System.Drawing.Size(31, 13);
            this.Port_Text.TabIndex = 10;
            this.Port_Text.Text = "4000";
            this.Port_Text.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.Port_Text.UseMnemonic = false;
            // 
            // Temperatur
            // 
            this.Temperatur.AutoSize = true;
            this.Temperatur.Location = new System.Drawing.Point(94, 103);
            this.Temperatur.Name = "Temperatur";
            this.Temperatur.Size = new System.Drawing.Size(61, 13);
            this.Temperatur.TabIndex = 9;
            this.Temperatur.Text = "Temperatur";
            // 
            // Type_Label
            // 
            this.Type_Label.AutoSize = true;
            this.Type_Label.Location = new System.Drawing.Point(16, 103);
            this.Type_Label.Name = "Type_Label";
            this.Type_Label.Size = new System.Drawing.Size(64, 13);
            this.Type_Label.TabIndex = 8;
            this.Type_Label.Text = "Sensor-Typ:";
            this.Type_Label.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // Server_Box
            // 
            this.Server_Box.Location = new System.Drawing.Point(97, 21);
            this.Server_Box.Name = "Server_Box";
            this.Server_Box.Size = new System.Drawing.Size(114, 20);
            this.Server_Box.TabIndex = 0;
            this.Server_Box.Text = "192.168.1.199";
            this.Server_Box.TextChanged += new System.EventHandler(this.Server_Box_TextChanged);
            // 
            // Abfrage_Button
            // 
            this.Abfrage_Button.Location = new System.Drawing.Point(69, 147);
            this.Abfrage_Button.Name = "Abfrage_Button";
            this.Abfrage_Button.Size = new System.Drawing.Size(97, 23);
            this.Abfrage_Button.TabIndex = 7;
            this.Abfrage_Button.Text = "Abfragen";
            this.Abfrage_Button.UseVisualStyleBackColor = true;
            this.Abfrage_Button.Click += new System.EventHandler(this.Abfrage_Button_Click);
            // 
            // MessPort_Label
            // 
            this.MessPort_Label.AutoSize = true;
            this.MessPort_Label.Location = new System.Drawing.Point(16, 76);
            this.MessPort_Label.Name = "MessPort_Label";
            this.MessPort_Label.Size = new System.Drawing.Size(57, 13);
            this.MessPort_Label.TabIndex = 2;
            this.MessPort_Label.Text = "Mess-Port:";
            this.MessPort_Label.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // Server_Label
            // 
            this.Server_Label.AutoSize = true;
            this.Server_Label.Location = new System.Drawing.Point(16, 24);
            this.Server_Label.Name = "Server_Label";
            this.Server_Label.Size = new System.Drawing.Size(41, 13);
            this.Server_Label.TabIndex = 1;
            this.Server_Label.Text = "Server:";
            this.Server_Label.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // Port_Label
            // 
            this.Port_Label.AutoSize = true;
            this.Port_Label.Location = new System.Drawing.Point(16, 49);
            this.Port_Label.Name = "Port_Label";
            this.Port_Label.Size = new System.Drawing.Size(29, 13);
            this.Port_Label.TabIndex = 5;
            this.Port_Label.Text = "Port:";
            this.Port_Label.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // Anzeige_Panel
            // 
            this.Anzeige_Panel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.Anzeige_Panel.Controls.Add(this.Type_Display_Label);
            this.Anzeige_Panel.Controls.Add(this.Anzeige);
            this.Anzeige_Panel.Controls.Add(this.Anzeige_Text);
            this.Anzeige_Panel.Location = new System.Drawing.Point(3, 3);
            this.Anzeige_Panel.Name = "Anzeige_Panel";
            this.Anzeige_Panel.Size = new System.Drawing.Size(235, 192);
            this.Anzeige_Panel.TabIndex = 1;
            // 
            // Type_Display_Label
            // 
            this.Type_Display_Label.AutoSize = true;
            this.Type_Display_Label.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Type_Display_Label.Location = new System.Drawing.Point(3, 76);
            this.Type_Display_Label.Name = "Type_Display_Label";
            this.Type_Display_Label.Size = new System.Drawing.Size(0, 20);
            this.Type_Display_Label.TabIndex = 1;
            this.Type_Display_Label.UseWaitCursor = true;
            // 
            // Anzeige
            // 
            this.Anzeige.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(219)))), ((int)(((byte)(221)))), ((int)(((byte)(236)))));
            this.Anzeige.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.Anzeige.Font = new System.Drawing.Font("Microsoft Sans Serif", 20F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Anzeige.ForeColor = System.Drawing.Color.Red;
            this.Anzeige.Location = new System.Drawing.Point(118, 66);
            this.Anzeige.Multiline = false;
            this.Anzeige.Name = "Anzeige";
            this.Anzeige.ReadOnly = true;
            this.Anzeige.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.None;
            this.Anzeige.Size = new System.Drawing.Size(112, 35);
            this.Anzeige.TabIndex = 0;
            this.Anzeige.Text = "";
            // 
            // Anzeige_Text
            // 
            this.Anzeige_Text.AutoSize = true;
            this.Anzeige_Text.Location = new System.Drawing.Point(88, 26);
            this.Anzeige_Text.Name = "Anzeige_Text";
            this.Anzeige_Text.Size = new System.Drawing.Size(48, 13);
            this.Anzeige_Text.TabIndex = 0;
            this.Anzeige_Text.Text = "Anzeige:";
            // 
            // GUI
            // 
            this.ClientSize = new System.Drawing.Size(507, 223);
            this.Controls.Add(this.splitContainer1);
            this.Name = "GUI";
            this.ShowIcon = false;
            this.Text = "Messwert-Abfrage";
            this.Load += new System.EventHandler(this.GUI_Load);
            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.ResumeLayout(false);
            this.Select_Panel.ResumeLayout(false);
            this.Select_Panel.PerformLayout();
            this.Anzeige_Panel.ResumeLayout(false);
            this.Anzeige_Panel.PerformLayout();
            this.ResumeLayout(false);

        }

            

        //Ereigniss, falls der Abfrage-Button angeklickt wurde
        private void Abfrage_Button_Click(object sender, EventArgs e)
        {
            //erstellen eines Servers
            Server serve = new Server("Testserver",Server_Box.Text,4000);
            //bereitstellen des MResult und der Connection
            MResult data = null;
            Connection con = null;
            
            try
            {
                //Verbindungsmglichkeit zu dem Server wird erstellt
                con = new Connection(serve);
                //senden des Werts in der MessPort_Box
                //gleichzeitige speicherung in data
                data = con.receiveResult(MessPort_Box.Text);
            }
            /*
             * Abfangen der Exceptions falls ein Verbindungsfehler
             * aufgetreten oder falls Nutzereingaben Fehlerhaft
             * waren
             */
            catch (System.Net.Sockets.SocketException ex)
            {
                MessageBox.Show(null, "Bitte berprfen Sie Ihre Einstellungen! (Server)", "Socket-Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                if (con.is_connected) con.close();
                this.Anzeige.Clear();
                this.Type_Display_Label.Text = "";
            }
            catch (System.IO.IOException ex)
            {
                MessageBox.Show(null, "Bitte berprfen Sie Ihre Einstellungen! (Mess-Port)", "IO-Error",MessageBoxButtons.OK , MessageBoxIcon.Error);
                if (con.is_connected) con.close();
                this.Anzeige.Clear();
                this.Type_Display_Label.Text = "";
            }
                       
            /*
             *Umsetzung der Anzeige des Messwert-Ergebnisses
             *wenn ein Fehler bei der Verbindung vorlag
             *ist data == null
             * Weiterhin erfolgt eine berprfung ob das
             * Meergebnis gltig ist
             * 
             */
            
            if (data != null)
            {
                if (data.isIsvalid())
                {
                    this.Anzeige.Clear();
                    this.Anzeige.AppendText(" " + data.getValue().ToString() + "C");
                    Type_Display_Label.Text = "Temperatur:";
                }
                else
                {
                    MessageBox.Show(null, "Der Mewert ist ungltig, bitte berprfen Sie die den Mesensor", "Me-Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Anzeige.Clear();
                    this.Type_Display_Label.Text = "";
                }

            }      

        }

        private void GUI_Load(object sender, EventArgs e)
        {

        }

        private void Server_Box_TextChanged(object sender, EventArgs e)
        {

        }
            
	}

   }
